



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>selenium 添加动态隧道代理</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">selenium 添加动态隧道代理</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 07:40:19 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<pre class="prettyprint linenums"># 无须密码验证方法

chromeOptions = webdriver.ChromeOptions()<br />
chromeOptions.add_argument('--proxy-server=http://ip:port')<br />
driver = webdriver.Chrome(chrome_options=chromeOptions)
</pre>
</div>
<p>　</p>
<p>密码验证(动态与隧道代理)</p>
<div>
<pre class="prettyprint linenums">#!/usr/bin/env python<br />
# -*- coding: utf-8 -*-<br />
from __future__ import print_function

from selenium import webdriver<br />
from selenium.webdriver.chrome.options import Options

def create_proxyauth_extension(proxy_host, proxy_port,<br />
                               proxy_username, proxy_password,<br />
                               scheme='http', plugin_path=None):<br />
    """Proxy Auth Extension

    args:<br />
        proxy_host (str): domain or ip address, ie proxy.domain.com<br />
        proxy_port (int): port<br />
        proxy_username (str): auth username<br />
        proxy_password (str): auth password<br />
    kwargs:<br />
        scheme (str): proxy scheme, default http<br />
        plugin_path (str): absolute path of the extension

    return str -&gt; plugin_path<br />
    """<br />
    import string<br />
    import zipfile

    if plugin_path is None:<br />
        plugin_path = '/tmp/vimm_chrome_proxyauth_plugin.zip'

    manifest_json = """<br />
    {<br />
        "version": "1.0.0",<br />
        "manifest_version": 2,<br />
        "name": "Chrome Proxy",<br />
        "permissions": [<br />
            "proxy",<br />
            "tabs",<br />
            "unlimitedStorage",<br />
            "storage",<br />
            "&lt;all_urls&gt;",<br />
            "webRequest",<br />
            "webRequestBlocking"<br />
        ],<br />
        "background": {<br />
            "scripts": ["background.js"]<br />
        },<br />
        "minimum_chrome_version":"22.0.0"<br />
    }<br />
    """

    background_js = string.Template(<br />
    """<br />
    var config = {<br />
            mode: "fixed_servers",<br />
            rules: {<br />
              singleProxy: {<br />
                scheme: "${scheme}",<br />
                host: "${host}",<br />
                port: parseInt(${port})<br />
              },<br />
              bypassList: ["foobar.com"]<br />
            }<br />
          };

    chrome.proxy.settings.set({value: config, scope: "regular"}, function() {});

    function callbackFn(details) {<br />
        return {<br />
            authCredentials: {<br />
                username: "${username}",<br />
                password: "${password}"<br />
            }<br />
        };<br />
    }

    chrome.webRequest.onAuthRequired.addListener(<br />
                callbackFn,<br />
                {urls: ["&lt;all_urls&gt;"]},<br />
                ['blocking']<br />
    );<br />
    """<br />
    ).substitute(<br />
        host=proxy_host,<br />
        port=proxy_port,<br />
        username=proxy_username,<br />
        password=proxy_password,<br />
        scheme=scheme,<br />
    )<br />
    with zipfile.ZipFile(plugin_path, 'w') as zp:<br />
        zp.writestr("manifest.json", manifest_json)<br />
        zp.writestr("background.js", background_js)

    return plugin_path

proxyauth_plugin_path = create_proxyauth_extension(<br />
    proxy_host="transfer.mogumiao.com",<br />
    proxy_port=9001,<br />
    proxy_username="username",                              # 输入隧道账号<br />
    proxy_password="passwod"                               # 输入密码<br />
)

co = Options()<br />
co.add_argument("--start-maximized")<br />
co.add_extension(proxyauth_plugin_path)

driver = webdriver.Chrome(chrome_options=co)<br />
driver.get("https://www.baidu.com/")
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7zolj9.html">angularJs 控制文本长度，超出省略号过滤器</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy1lmxq.html">Makefile笔记之二------make的递归执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkx7x9.html">Scala中Iterator允许执行一次</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ggvv8.html">flash 定义二维数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8krdjjq.html">WIN-CE系统架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq162x48.html">Zyxel Switch-How to block a fake DHCP server without enabling DHCP snooping&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzzz68.html">Mybatis-Plugin插件学习使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1rdx79.html">JavaScript基础大全篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xpgk9.html">Java编程思想（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljm5e09.html">JavaScript 进阶（一）JS的&amp;quot&semi;多线程&amp;quot&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z557j9.html">&period;net 4种单例模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdloj49.html">jenkins安装配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj152r8.html">记录阿里云服务器mysql被黑</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p15z48.html">SQL 中左连接与右链接的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjmdo09.html">ZIP、tar&period;gz压缩时排除指定目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll40pkq.html">ApplicationContext之getBean方法详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/953d6m08.html">PHP 运行相关概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjromvq.html">jsp编译原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kl34oq.html">RPM包下载网址</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emvl2z9.html">Angular动态表单生成（一）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gjmjzz9.html">c&sol;c&plus;&plus; 栈与队列实现车库的出入与收费</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdn2yj9.html">vue-resource&plus;element upload上传（遇到formData总是变为object格式）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j10m4e9.html">linux 安装 ftp 实现文件共享</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25w3o3q.html">我的代码-sql query</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyd0djq.html">c&num; excel xls保存</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdn4w09.html">ubuntu 安装 pycharm</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jy6j3q.html">20164301 Exp4 恶意代码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jywgnq.html">Go 字符串连接&plus;&equals;与strings&period;Join性能对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rvlw39.html">使用samba共享文件夹，提供给window访问</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j10rml9.html">Centos7快速部署CloudStack服务器</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
